------------------------------------------------
-- Fix any issues
------------------------------------------------
UPDATE FCM_USER_ALERT_TYPE 
		SET LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP - CURRENT TIMEZONE ,
		LSTUPDT_USER = 'system'@

UPDATE FCM_ROLE_PRIVILEGE 
		SET LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP - CURRENT TIMEZONE ,
		LSTUPDT_USER = 'system'@	

UPDATE FCM_USER_ROLE 
		SET LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP - CURRENT TIMEZONE ,
		LSTUPDT_USER = 'system'@
		
UPDATE FCM_USER_BUS_UNIT
		SET LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP - CURRENT TIMEZONE ,
		LSTUPDT_USER = 'system'@

UPDATE FCM_USER_MESSAGE
		SET LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP - CURRENT TIMEZONE ,
		LSTUPDT_USER = 'system'@

------------------------------------------------
-- Drop Triggers being replaced
------------------------------------------------
DROP TRIGGER TRU_ALERT_FULFILL  @
DROP TRIGGER TRU_ARD_BBW        @
DROP TRIGGER TRU__BLK_QCALLRES  @
DROP TRIGGER TRU_FRD_QCALLRES   @
DROP TRIGGER TRU_GROUP          @
DROP TRIGGER TRU_MERCHANT_BBW   @
DROP TRIGGER TRU_MODEL          @
DROP TRIGGER TRU_POS_BBW        @
DROP TRIGGER TRU_PROPERTY       @
DROP TRIGGER TRU_QCALLRES       @
DROP TRIGGER TRU_QUEUE          @
DROP TRIGGER TRU_RER_QCALLRES   @
DROP TRIGGER TRU_SIC_BBW        @
DROP TRIGGER TRU_STRATEGY_USER  @
DROP TRIGGER TRU_STRATEGY       @
DROP TRIGGER TRU_TEMPLATE_QUEUE @
DROP TRIGGER TRU_TEMPLATE       @
DROP TRIGGER TRU_TPLT_STRATEGY  @
DROP TRIGGER TRU_USER_AUDIT     @
DROP TRIGGER TRU_USER           @
DROP TRIGGER TRU_USR_ALRTTYPE   @
DROP TRIGGER TRU_ALERT_TYPE     @
DROP TRIGGER TRU_ROLE           @
DROP TRIGGER TRU_PRIVILEGE      @
DROP TRIGGER TRU_BUSINESS_UNIT  @
DROP TRIGGER TRU_MESSAGE        @




------------------------------------------------
-- DDL Statements for TRIGGER TRU_ALERT_FULFILL
------------------------------------------------

CREATE TRIGGER TRU_ALERT_FULFILL
  AFTER UPDATE OF 
	  FULFILLMENT_ID,
	  FULFILLMENT_TIMESTAMP,
	  ALERT_ACTION_ID,
	  MEMO_TEMPLATE_ID,
	  SENT_SMS_TEMPLATE_ID,
	  SENT_LETTER_TEMPLATE_ID,
	  SENT_EMAIL_TEMPLATE_ID,
	  SENT_EMAIL_IND,
	  SENT_LETTER_IND,
	  SENT_SMS_IND,
	  FULFILL_SENT_CODE,
	  FULFILL_SUBMIT_CNT,
	  FULFILL_FUNCTION_CODE,
	  FULFILL_TEXT_PROOF_CODE_1,
	  FULFILL_TEXT_PROOF_CODE_2,
	  FULFILL_TEXT_PROOF_CODE_3,
	  FULFILL_MERCH_ACCT_TYPE,
	  FULFILL_ATTN_NAME,
	  FULFILL_CHECK_AMT,
	  FULFILL_PAYEE_NAME,
	  FULFILL_NAME_1,
	  FULFILL_NAME_2,
	  FULFILL_ADDR_LINE_1,
	  FULFILL_ADDR_LINE_2,
	  FULFILL_ADDR_CITY_NAME,
	  FULFILL_ADDR_STATE_PROV_CODE,
	  FULFILL_ADDR_POSTAL_CODE,
	  FULFILL_ADDR_CNTRY_CODE,
	  FULFILL_MERCH_CNTRY_NAMES,
	  GRX_CH_NAME_1,
	  GRX_LANG_CODE,
	  GRX_CH_1_MOBILE_1,
	  GRX_CH_EMAIL_1,
	  MEMO_TEXT,
	  MEMO_TYPE,
	  SENT_SECURE_MESSAGE_IND,
	  INVALID_CONTACT_DETAILS_IND,
	  TRANS_DATE_RANGE_BEGIN , 
	  TRANS_DATE_RANGE_END ,
	  TRANS_TOTAL_AMT ,
	  TEMPLATE_TEXT,
	  CREATE_TIMESTAMP,
	  CREATE_USER
  ON FCM_ALERT_FULFILLMENT
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_ALERT_FULFILLMENT 	(
	  FULFILLMENT_ID,
	  FULFILLMENT_TIMESTAMP,
	  ALERT_ACTION_ID,
	  MEMO_TEMPLATE_ID,
	  SENT_SMS_TEMPLATE_ID,
	  SENT_LETTER_TEMPLATE_ID,
	  SENT_EMAIL_TEMPLATE_ID,
	  SENT_EMAIL_IND,
	  SENT_LETTER_IND,
	  SENT_SMS_IND,
	  FULFILL_SENT_CODE,
	  FULFILL_SUBMIT_CNT,
	  FULFILL_FUNCTION_CODE,
	  FULFILL_TEXT_PROOF_CODE_1,
	  FULFILL_TEXT_PROOF_CODE_2,
	  FULFILL_TEXT_PROOF_CODE_3,
	  FULFILL_MERCH_ACCT_TYPE,
	  FULFILL_ATTN_NAME,
	  FULFILL_CHECK_AMT,
	  FULFILL_PAYEE_NAME,
	  FULFILL_NAME_1,
	  FULFILL_NAME_2,
	  FULFILL_ADDR_LINE_1,
	  FULFILL_ADDR_LINE_2,
	  FULFILL_ADDR_CITY_NAME,
	  FULFILL_ADDR_STATE_PROV_CODE,
	  FULFILL_ADDR_POSTAL_CODE,
	  FULFILL_ADDR_CNTRY_CODE,
	  FULFILL_MERCH_CNTRY_NAMES,
	  GRX_CH_NAME_1,
	  GRX_LANG_CODE,
	  GRX_CH_1_MOBILE_1,
	  GRX_CH_EMAIL_1,
	  MEMO_TEXT,
	  MEMO_TYPE,
	  SENT_SECURE_MESSAGE_IND,
	  INVALID_CONTACT_DETAILS_IND,
	  TRANS_DATE_RANGE_BEGIN , 
	  TRANS_DATE_RANGE_END ,
	  TRANS_TOTAL_AMT ,
	  TEMPLATE_TEXT ,
	  CREATE_TIMESTAMP,
	  CREATE_USER,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.FULFILLMENT_ID,
	  NEW.FULFILLMENT_TIMESTAMP,
	  NEW.ALERT_ACTION_ID,
	  NEW.MEMO_TEMPLATE_ID,
	  NEW.SENT_SMS_TEMPLATE_ID,
	  NEW.SENT_LETTER_TEMPLATE_ID,
	  NEW.SENT_EMAIL_TEMPLATE_ID,
	  NEW.SENT_EMAIL_IND,
	  NEW.SENT_LETTER_IND,
	  NEW.SENT_SMS_IND,
	  NEW.FULFILL_SENT_CODE,
	  NEW.FULFILL_SUBMIT_CNT,
	  NEW.FULFILL_FUNCTION_CODE,
	  NEW.FULFILL_TEXT_PROOF_CODE_1,
	  NEW.FULFILL_TEXT_PROOF_CODE_2,
	  NEW.FULFILL_TEXT_PROOF_CODE_3,
	  NEW.FULFILL_MERCH_ACCT_TYPE,
	  NEW.FULFILL_ATTN_NAME,
	  NEW.FULFILL_CHECK_AMT,
	  NEW.FULFILL_PAYEE_NAME,
	  NEW.FULFILL_NAME_1,
	  NEW.FULFILL_NAME_2,
	  NEW.FULFILL_ADDR_LINE_1,
	  NEW.FULFILL_ADDR_LINE_2,
	  NEW.FULFILL_ADDR_CITY_NAME,
	  NEW.FULFILL_ADDR_STATE_PROV_CODE,
	  NEW.FULFILL_ADDR_POSTAL_CODE,
	  NEW.FULFILL_ADDR_CNTRY_CODE,
	  NEW.FULFILL_MERCH_CNTRY_NAMES,
	  NEW.GRX_CH_NAME_1,
	  NEW.GRX_LANG_CODE,
	  NEW.GRX_CH_1_MOBILE_1,
	  NEW.GRX_CH_EMAIL_1,
	  NEW.MEMO_TEXT,
	  NEW.MEMO_TYPE,
	  NEW.SENT_SECURE_MESSAGE_IND,
	  NEW.INVALID_CONTACT_DETAILS_IND,
	  NEW.TRANS_DATE_RANGE_BEGIN , 
	  NEW.TRANS_DATE_RANGE_END ,
	  NEW.TRANS_TOTAL_AMT ,
	  NEW.TEMPLATE_TEXT ,
	  NEW.CREATE_TIMESTAMP,
	  NEW.CREATE_USER,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_ALERT_TYPE
------------------------------------------------

CREATE TRIGGER TRU_ALERT_TYPE
  AFTER UPDATE OF 
	  ALERT_TYPE,
	  KEY_FIELD_ID,
	  DEMOG_SOR_KEY_FIELD_ID,
	  DEMOG_RH_KEY_FIELD_ID,
	  DEMOG_SOR_TABLE,
	  DEMOG_RH_TABLE,
	  ALERT_TYPE_NAME,
	  ALERT_TYPE_SHORT_NAME,
	  ALERT_TYPE_DESC,
	  CREATE_TIMESTAMP,
	  CREATE_USER,
	  LOGICAL_DEL_IND
  ON FCM_ALERT_TYPE
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_ALERT_TYPE 	(
	  ALERT_TYPE,
	  KEY_FIELD_ID,
	  DEMOG_SOR_KEY_FIELD_ID,
	  DEMOG_RH_KEY_FIELD_ID,
	  DEMOG_SOR_TABLE,
	  DEMOG_RH_TABLE,
	  ALERT_TYPE_NAME,
	  ALERT_TYPE_SHORT_NAME,
	  ALERT_TYPE_DESC,
	  CREATE_TIMESTAMP,
	  CREATE_USER,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.ALERT_TYPE,
	  NEW.KEY_FIELD_ID,
	  NEW.DEMOG_SOR_KEY_FIELD_ID,
	  NEW.DEMOG_RH_KEY_FIELD_ID,
	  NEW.DEMOG_SOR_TABLE,
	  NEW.DEMOG_RH_TABLE,
	  NEW.ALERT_TYPE_NAME,
	  NEW.ALERT_TYPE_SHORT_NAME,
	  NEW.ALERT_TYPE_DESC,
	  NEW.CREATE_TIMESTAMP,
	  NEW.CREATE_USER,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
	
	UPDATE FCM_USER_ALERT_TYPE 
		SET LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP - CURRENT TIMEZONE ,
		LSTUPDT_USER = 'system'
	WHERE
		ALERT_TYPE =  NEW.ALERT_TYPE;
END@

------------------------------------------------
-- DDL Statements for TRIGGER TRU_ARD_BBW
------------------------------------------------

CREATE TRIGGER TRU_ARD_BBW
  AFTER UPDATE OF 
	  ARD_BBW_ID,
	  RRR_ACTION_CODE,
	  QUEUE_CALL_RESULT_ID,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_ARD_BBW
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_ARD_BBW 	(
	  ARD_BBW_ID,
	  RRR_ACTION_CODE,
	  QUEUE_CALL_RESULT_ID,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.ARD_BBW_ID,
	  NEW.RRR_ACTION_CODE,
	  NEW.QUEUE_CALL_RESULT_ID,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU__BLK_QCALLRES
------------------------------------------------

CREATE TRIGGER TRU_BLK_QCALLRES
  AFTER UPDATE OF 
	  BLOCK_ID,
	  QUEUE_CALL_RESULT_ID,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_BLOCK_QUEUE_CALL_RESULT
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_BLOCK_QUEUE_CALL_RESULT 	(
	  BLOCK_ID,
	  QUEUE_CALL_RESULT_ID,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.BLOCK_ID,
	  NEW.QUEUE_CALL_RESULT_ID,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_BUSINESS_UNIT
------------------------------------------------

CREATE TRIGGER TRU_BUSINESS_UNIT
  AFTER UPDATE OF 
	  BUSINESS_UNIT_ID,
	  BUSINESS_UNIT_NAME,
	  BUSINESS_UNIT_DESC,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_BUSINESS_UNIT
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_BUSINESS_UNIT 	(
	  BUSINESS_UNIT_ID,
	  BUSINESS_UNIT_NAME,
	  BUSINESS_UNIT_DESC,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.BUSINESS_UNIT_ID,
	  NEW.BUSINESS_UNIT_NAME,
	  NEW.BUSINESS_UNIT_DESC,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
	UPDATE FCM_USER_BUS_UNIT 
		SET LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP - CURRENT TIMEZONE ,
		LSTUPDT_USER = 'system'
	WHERE
		BUSINESS_UNIT_ID =  NEW.BUSINESS_UNIT_ID;	
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_FRD_QCALLRES
------------------------------------------------

CREATE TRIGGER TRU_FRD_QCALLRES
  AFTER UPDATE OF 
	  QUEUE_CALL_RESULT_ID,
	  FRAUD_TYPE_CODE,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_FRAUD_QUEUE_CALL_RESULT
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_FRAUD_QUEUE_CALL_RESULT 	(
	  QUEUE_CALL_RESULT_ID,
	  FRAUD_TYPE_CODE,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.QUEUE_CALL_RESULT_ID,
	  NEW.FRAUD_TYPE_CODE,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_GROUP
------------------------------------------------

CREATE TRIGGER TRU_GROUP
  AFTER UPDATE OF 
	  GROUP_ID,
	  PARENT_GROUP_ID,
	  BUSINESS_UNIT_ID,
	  SUPERVISOR_ID,
	  GROUP_NAME,
	  GROUP_TYPE_CODE,
	  GROUP_DESC,
	  GROUP_CODE,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_GROUP
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_GROUP 	(
	  GROUP_ID,
	  PARENT_GROUP_ID,
	  BUSINESS_UNIT_ID,
	  SUPERVISOR_ID,
	  GROUP_NAME,
	  GROUP_TYPE_CODE,
	  GROUP_DESC,
	  GROUP_CODE,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.GROUP_ID,
	  NEW.PARENT_GROUP_ID,
	  NEW.BUSINESS_UNIT_ID,
	  NEW.SUPERVISOR_ID,
	  NEW.GROUP_NAME,
	  NEW.GROUP_TYPE_CODE,
	  NEW.GROUP_DESC,
	  NEW.GROUP_CODE,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_MERCHANT_BBW
------------------------------------------------

CREATE TRIGGER TRU_MERCHANT_BBW
  AFTER UPDATE OF 
	  MERCH_BBW_ID,
	  QUEUE_CALL_RESULT_ID,
	  HCT_TERM_CNTRY_CODE,
	  NOT_IN_IND,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_MERCHANT_BBW
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_MERCHANT_BBW 	(
	  MERCH_BBW_ID,
	  QUEUE_CALL_RESULT_ID,
	  HCT_TERM_CNTRY_CODE,
	  NOT_IN_IND,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.MERCH_BBW_ID,
	  NEW.QUEUE_CALL_RESULT_ID,
	  NEW.HCT_TERM_CNTRY_CODE,
	  NEW.NOT_IN_IND,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_MESSAGE
------------------------------------------------

CREATE TRIGGER TRU_MESSAGE
  AFTER UPDATE OF 
	  MESSAGE_ID,
	  MESSAGE_TYPE_CODE,
	  MESSAGE_TXT,
	  MESSAGE_SUBJECT,
	  EFFECTV_START_DATE,
	  AUTHOR_USER_ID,
	  LOGICAL_DEL_IND
  ON FCM_MESSAGE
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_MESSAGE 	(
	  MESSAGE_ID,
	  MESSAGE_TYPE_CODE,
	  MESSAGE_TXT,
	  MESSAGE_SUBJECT,
	  EFFECTV_START_DATE,
	  AUTHOR_USER_ID,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.MESSAGE_ID,
	  NEW.MESSAGE_TYPE_CODE,
	  NEW.MESSAGE_TXT,
	  NEW.MESSAGE_SUBJECT,
	  NEW.EFFECTV_START_DATE,
	  NEW.AUTHOR_USER_ID,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);

	UPDATE FCM_USER_MESSAGE 
		SET LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP - CURRENT TIMEZONE ,
		LSTUPDT_USER = 'system'
	WHERE
		MESSAGE_ID =  NEW.MESSAGE_ID;
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_MODEL
------------------------------------------------

CREATE TRIGGER TRU_MODEL
  AFTER UPDATE OF 
	  MODEL_ID,
	  MODEL_NAME,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND,
	  MODEL_PACKAGE_ID_VERSION
  ON FCM_MODEL
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_MODEL 	(
	  MODEL_ID,
	  MODEL_NAME,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  MODEL_PACKAGE_ID_VERSION,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.MODEL_ID,
	  NEW.MODEL_NAME,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  NEW.MODEL_PACKAGE_ID_VERSION,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_POS_BBW
------------------------------------------------

CREATE TRIGGER TRU_POS_BBW
  AFTER UPDATE OF 
	  QUEUE_CALL_RESULT_ID,
	  POS_BBW_ID,
	  UCM_POS,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_POS_BBW
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_POS_BBW 	(
	  QUEUE_CALL_RESULT_ID,
	  POS_BBW_ID,
	  UCM_POS,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.QUEUE_CALL_RESULT_ID,
	  NEW.POS_BBW_ID,
	  NEW.UCM_POS,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_PRIVILEGE
------------------------------------------------

CREATE TRIGGER TRU_PRIVILEGE
  AFTER UPDATE OF 
	  PRIVILEGE_ID,
	  PRIVILEGE_DESC,
	  SYSTEM_PRIVILEGE_NAME,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_PRIVILEGE
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_PRIVILEGE 	(
	  PRIVILEGE_ID,
	  PRIVILEGE_DESC,
	  SYSTEM_PRIVILEGE_NAME,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.PRIVILEGE_ID,
	  NEW.PRIVILEGE_DESC,
	  NEW.SYSTEM_PRIVILEGE_NAME,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
	UPDATE FCM_ROLE_PRIVILEGE 
		SET LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP - CURRENT TIMEZONE ,
		LSTUPDT_USER = 'system'
	WHERE
		PRIVILEGE_ID =  NEW.PRIVILEGE_ID;
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_PROPERTY
------------------------------------------------

CREATE TRIGGER TRU_PROPERTY
  AFTER UPDATE OF 
	  PROPERTY_ID,
	  PROPERTY_NAME,
	  PROPERTY_VALUE,
	  PROPERTY_DESC,
	  PROPERTY_LABEL,
	  PROPERTY_TYPE,
	  CREATE_TIMESTAMP,
	  CREATE_USER,
	  LOGICAL_DEL_IND
  ON FCM_PROPERTY
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_PROPERTY 	(
	  PROPERTY_ID,
	  PROPERTY_NAME,
	  PROPERTY_VALUE,
	  PROPERTY_DESC,
	  PROPERTY_LABEL,
	  PROPERTY_TYPE,
	  CREATE_TIMESTAMP,
	  CREATE_USER,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.PROPERTY_ID,
	  NEW.PROPERTY_NAME,
	  NEW.PROPERTY_VALUE,
	  NEW.PROPERTY_DESC,
	  NEW.PROPERTY_LABEL,
	  NEW.PROPERTY_TYPE,
	  NEW.CREATE_TIMESTAMP,
	  NEW.CREATE_USER,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_QCALLRES
------------------------------------------------

CREATE TRIGGER TRU_QCALLRES
  AFTER UPDATE OF 
	  QUEUE_CALL_RESULT_ID,
	  RESULT_ID,
	  QUEUE_ID,
	  WAKE_IN_MINUTES,
	  WAKE_IN_MINUTES_IND,
	  WAKE_NEXT_DAY_IND,
	  WAKE_ON_SCORE_INCREASE,
	  WAKE_ON_SCORE_INCREASE_IND,
	  WAKE_ON_SCORE,
	  WAKE_ON_SCORE_IND,
	  WAKE_ON_AMT,
	  WAKE_ON_AMT_IND,
	  WAKE_AT_TIMESTAMP_IND,
	  WAKE_NEVER_IND,
	  WAKE_ON_SIC_IND,
	  WAKE_ON_NOT_SIC_IND,
	  WAKE_ON_COUNTRY_CODE_IND,
	  WAKE_ON_NOT_COUNTRY_CODE_IND,
	  WAKE_ON_ARD_IND,
	  WAKE_ON_POS_IND,
	  CALL_RESULT_AUTO_CLOSE_DAYS,
	  ENABLE_SYS_BLOCK_IND,
	  REMOVE_SYS_BLOCK_IND,
	  ENABLE_TRANS_BLOCK_IND,
	  REMOVE_TRANS_BLOCK_IND,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_QUEUE_CALL_RESULT
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_QUEUE_CALL_RESULT 	(
	  QUEUE_CALL_RESULT_ID,
	  RESULT_ID,
	  QUEUE_ID,
	  WAKE_IN_MINUTES,
	  WAKE_IN_MINUTES_IND,
	  WAKE_NEXT_DAY_IND,
	  WAKE_ON_SCORE_INCREASE,
	  WAKE_ON_SCORE_INCREASE_IND,
	  WAKE_ON_SCORE,
	  WAKE_ON_SCORE_IND,
	  WAKE_ON_AMT,
	  WAKE_ON_AMT_IND,
	  WAKE_AT_TIMESTAMP_IND,
	  WAKE_NEVER_IND,
	  WAKE_ON_SIC_IND,
	  WAKE_ON_NOT_SIC_IND,
	  WAKE_ON_COUNTRY_CODE_IND,
	  WAKE_ON_NOT_COUNTRY_CODE_IND,
	  WAKE_ON_ARD_IND,
	  WAKE_ON_POS_IND,
	  CALL_RESULT_AUTO_CLOSE_DAYS,
	  ENABLE_SYS_BLOCK_IND,
	  REMOVE_SYS_BLOCK_IND,
	  ENABLE_TRANS_BLOCK_IND,
	  REMOVE_TRANS_BLOCK_IND,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.QUEUE_CALL_RESULT_ID,
	  NEW.RESULT_ID,
	  NEW.QUEUE_ID,
	  NEW.WAKE_IN_MINUTES,
	  NEW.WAKE_IN_MINUTES_IND,
	  NEW.WAKE_NEXT_DAY_IND,
	  NEW.WAKE_ON_SCORE_INCREASE,
	  NEW.WAKE_ON_SCORE_INCREASE_IND,
	  NEW.WAKE_ON_SCORE,
	  NEW.WAKE_ON_SCORE_IND,
	  NEW.WAKE_ON_AMT,
	  NEW.WAKE_ON_AMT_IND,
	  NEW.WAKE_AT_TIMESTAMP_IND,
	  NEW.WAKE_NEVER_IND,
	  NEW.WAKE_ON_SIC_IND,
	  NEW.WAKE_ON_NOT_SIC_IND,
	  NEW.WAKE_ON_COUNTRY_CODE_IND,
	  NEW.WAKE_ON_NOT_COUNTRY_CODE_IND,
	  NEW.WAKE_ON_ARD_IND,
	  NEW.WAKE_ON_POS_IND,
	  NEW.CALL_RESULT_AUTO_CLOSE_DAYS,
	  NEW.ENABLE_SYS_BLOCK_IND,
	  NEW.REMOVE_SYS_BLOCK_IND,
	  NEW.ENABLE_TRANS_BLOCK_IND,
	  NEW.REMOVE_TRANS_BLOCK_IND,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@

------------------------------------------------
-- DDL Statements for TRIGGER TRU_QUEUE
------------------------------------------------

CREATE TRIGGER TRU_QUEUE
  AFTER UPDATE OF CREATE_TIMESTAMP, CREATE_USER, ENABLE_REROUTE_INBOUND_IND, LOGICAL_DEL_IND,
    QUEUE_AUTO_CLOSE_DAYS, QUEUE_CALL_LOWER_BOUND, QUEUE_CALL_SUPERSEDED_IND, 
    QUEUE_CALL_UPPER_BOUND, QUEUE_DESC, QUEUE_NAME, QUEUE_PRIORITY, QUEUE_PURGE_DAYS, 
    QUEUE_SORT_FIELD, QUEUE_SORT_ORDER, QUEUE_STATUS, QUEUE_STICKY_IND, QUEUE_INBOUND_IND,STRATEGY_ID
    
  ON FCM_QUEUE
  REFERENCING 
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
		 INSERT INTO FSX_QUEUE 	(QUEUE_ID,
STRATEGY_ID	,
GROUP_ID	,
QUEUE_PRIORITY	,
QUEUE_NAME	,
QUEUE_DESC	,
QUEUE_STATUS	,
QUEUE_SORT_FIELD	,
QUEUE_SORT_ORDER	,
QUEUE_CALL_LOWER_BOUND	,
QUEUE_CALL_UPPER_BOUND	,
QUEUE_CALL_SUPERSEDED_IND	,
QUEUE_AUTO_CLOSE_DAYS	,
QUEUE_PURGE_DAYS	,
QUEUE_STICKY_IND,
QUEUE_INBOUND_IND,
ENABLE_REROUTE_INBOUND_IND	,
CREATE_USER	,
CREATE_TIMESTAMP	,
LSTUPDT_USER	,
LSTUPDT_TIMESTAMP	,
LSTUPDT_NBR		,
LOGICAL_DEL_IND			,
STRATEGY_NAME	,
  STRATEGY_PRIORITY	,
  STRATEGY_DESC	,
  STRATEGY_SORT_ORDER	,
  STRATEGY_STATUS	,
  STRATEGY_TYPE_CODE	,
  STRATEGY_SERVICE_MODE	,
BUSINESS_UNIT_ID	,
FSX_ACTION_TYPE,
FSX_CREATE_TIMESTAMP) 
select
NEW.QUEUE_ID,
NEW.STRATEGY_ID	,
strat.GROUP_ID	,
NEW.QUEUE_PRIORITY	,
NEW.QUEUE_NAME	,
NEW.QUEUE_DESC	,
NEW.QUEUE_STATUS	,
NEW.QUEUE_SORT_FIELD	,
NEW.QUEUE_SORT_ORDER	,
NEW.QUEUE_CALL_LOWER_BOUND	,
NEW.QUEUE_CALL_UPPER_BOUND	,
NEW.QUEUE_CALL_SUPERSEDED_IND	,
NEW.QUEUE_AUTO_CLOSE_DAYS	,
NEW.QUEUE_PURGE_DAYS	,
NEW.QUEUE_STICKY_IND,
NEW.QUEUE_INBOUND_IND,
NEW.ENABLE_REROUTE_INBOUND_IND	,
NEW.CREATE_USER	,
NEW.CREATE_TIMESTAMP	,
NEW.LSTUPDT_USER	,
NEW.LSTUPDT_TIMESTAMP	,
NEW.LSTUPDT_NBR		,
NEW.LOGICAL_DEL_IND			,
strat.STRATEGY_NAME	,
  strat.STRATEGY_PRIORITY	,
  strat.STRATEGY_DESC	,
  strat.STRATEGY_SORT_ORDER	,
  strat.STRATEGY_STATUS	,
  strat.STRATEGY_TYPE_CODE	,
  strat.STRATEGY_SERVICE_MODE	,
strat.BUSINESS_UNIT_ID	,
'UPDATE',
CURRENT TIMESTAMP
from fcm_strategy strat 
where strategy_id = new.strategy_id;
END@

------------------------------------------------
-- DDL Statements for TRIGGER TRU_RER_QCALLRES
------------------------------------------------

CREATE TRIGGER TRU_RER_QCALLRES
  AFTER UPDATE OF 
	  QUEUE_CALL_RESULT_ID,
	  REROUTE_QUEUE_ID,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_REROUTE_QUEUE_CALL_RESULT
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_REROUTE_QUEUE_CALL_RESULT 	(
	  QUEUE_CALL_RESULT_ID,
	  REROUTE_QUEUE_ID,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.QUEUE_CALL_RESULT_ID,
	  NEW.REROUTE_QUEUE_ID,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_ROLE
------------------------------------------------

CREATE TRIGGER TRU_ROLE
  AFTER UPDATE OF 
	  ROLE_ID,
	  ROLE_NAME,
	  ROLE_DESC,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_ROLE
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_ROLE 	(
	  ROLE_ID,
	  ROLE_NAME,
	  ROLE_DESC,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.ROLE_ID,
	  NEW.ROLE_NAME,
	  NEW.ROLE_DESC,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
	UPDATE FCM_USER_ROLE 
		SET LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP - CURRENT TIMEZONE ,
		LSTUPDT_USER = 'system'
	WHERE
		ROLE_ID =  NEW.ROLE_ID;
		
	UPDATE FCM_ROLE_PRIVILEGE 
		SET LSTUPDT_TIMESTAMP = CURRENT TIMESTAMP - CURRENT TIMEZONE ,
		LSTUPDT_USER = 'system'
	WHERE
		ROLE_ID =  NEW.ROLE_ID;		
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_SIC_BBW
------------------------------------------------

CREATE TRIGGER TRU_SIC_BBW
  AFTER UPDATE OF 
	  SIC_BBW_ID,
	  QUEUE_CALL_RESULT_ID,
	  HCT_MER_MCC,
	  NOT_IN_IND,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_SIC_BBW
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_SIC_BBW 	(
	  SIC_BBW_ID,
	  QUEUE_CALL_RESULT_ID,
	  HCT_MER_MCC,
	  NOT_IN_IND,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.SIC_BBW_ID,
	  NEW.QUEUE_CALL_RESULT_ID,
	  NEW.HCT_MER_MCC,
	  NEW.NOT_IN_IND,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_STRATEGY_USER
------------------------------------------------

CREATE TRIGGER TRU_STRATEGY_USER
  AFTER UPDATE OF 
	  STRATEGY_ID,
	  USER_ID,
	  CREATE_USER,
	  CREATE_TIMESTAMP
  ON FCM_STRATEGY_USER
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_STRATEGY_USER 	(
	  STRATEGY_ID,
	  USER_ID,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.STRATEGY_ID,
	  NEW.USER_ID,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  '0',
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_STRATEGY
------------------------------------------------

CREATE TRIGGER TRU_STRATEGY
  AFTER UPDATE OF 
	  STRATEGY_ID,
	  BUSINESS_UNIT_ID,
	  GROUP_ID,
	  GRID_TEMPLATE_ID,
	  STRATEGY_NAME,
	  STRATEGY_PRIORITY,
	  STRATEGY_DESC,
	  STRATEGY_SORT_ORDER,
	  STRATEGY_STATUS,
	  STRATEGY_TYPE_CODE,
	  STRATEGY_SERVICE_MODE,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_STRATEGY
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_STRATEGY 	(
	  STRATEGY_ID,
	  BUSINESS_UNIT_ID,
	  GROUP_ID,
	  GRID_TEMPLATE_ID,
	  STRATEGY_NAME,
	  STRATEGY_PRIORITY,
	  STRATEGY_DESC,
	  STRATEGY_SORT_ORDER,
	  STRATEGY_STATUS,
	  STRATEGY_TYPE_CODE,
	  STRATEGY_SERVICE_MODE,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.STRATEGY_ID,
	  coalesce(NEW.BUSINESS_UNIT_ID,-1),
	  NEW.GROUP_ID,
	  NEW.GRID_TEMPLATE_ID,
	  NEW.STRATEGY_NAME,
	  NEW.STRATEGY_PRIORITY,
	  NEW.STRATEGY_DESC,
	  NEW.STRATEGY_SORT_ORDER,
	  NEW.STRATEGY_STATUS,
	  NEW.STRATEGY_TYPE_CODE,
	  NEW.STRATEGY_SERVICE_MODE,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_TEMPLATE_QUEUE
------------------------------------------------

CREATE TRIGGER TRU_TEMPLATE_QUEUE
  AFTER UPDATE OF 
	  TEMPLATE_ID,
	  QUEUE_ID,
	  DEFAULT_TEMPLATE_IND,
	  CREATE_USER,
	  CREATE_TIMESTAMP
  ON FCM_TEMPLATE_QUEUE
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_TEMPLATE_QUEUE 	(
	  TEMPLATE_ID,
	  QUEUE_ID,
	  DEFAULT_TEMPLATE_IND,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.TEMPLATE_ID,
	  NEW.QUEUE_ID,
	  NEW.DEFAULT_TEMPLATE_IND,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  '0',
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_TEMPLATE
------------------------------------------------

CREATE TRIGGER TRU_TEMPLATE
  AFTER UPDATE OF 
	  TEMPLATE_ID,
	  TEMPLATE_HOST_KEY,
	  TEMPLATE_TYPE_CODE,
	  TEMPLATE_NAME,
	  TEMPLATE_LOCALE,
	  TEMPLATE_TEXT,
	  BUSINESS_UNIT_ID,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_TEMPLATE
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_TEMPLATE 	(
	  TEMPLATE_ID,
	  TEMPLATE_HOST_KEY,
	  TEMPLATE_TYPE_CODE,
	  TEMPLATE_NAME,
	  TEMPLATE_LOCALE,
	  TEMPLATE_TEXT,
	  BUSINESS_UNIT_ID,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.TEMPLATE_ID,
	  NEW.TEMPLATE_HOST_KEY,
	  NEW.TEMPLATE_TYPE_CODE,
	  NEW.TEMPLATE_NAME,
	  NEW.TEMPLATE_LOCALE,
	  NEW.TEMPLATE_TEXT,
	  NEW.BUSINESS_UNIT_ID,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_TPLT_STRATEGY
------------------------------------------------

CREATE TRIGGER TRU_TPLT_STRATEGY
  AFTER UPDATE OF 
	  TEMPLATE_ID,
	  STRATEGY_ID,
	  DEFAULT_TEMPLATE_IND,
	  CREATE_USER,
	  CREATE_TIMESTAMP
  ON FCM_TEMPLATE_STRATEGY
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_TEMPLATE_STRATEGY 	(
	  TEMPLATE_ID,
	  STRATEGY_ID,
	  DEFAULT_TEMPLATE_IND,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.TEMPLATE_ID,
	  NEW.STRATEGY_ID,
	  NEW.DEFAULT_TEMPLATE_IND,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  '0',
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_USER_AUDIT
------------------------------------------------

CREATE TRIGGER TRU_USER_AUDIT
  AFTER UPDATE OF 
	  AUDIT_ID,
	  USER_NAME,
	  LOGIN_TIMESTAMP,
	  LOGOUT_TIMESTAMP,
	  CREATE_USER,
	  CREATE_TIMESTAMP
  ON FCM_USER_AUDIT
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_USER_AUDIT 	(
	  AUDIT_ID,
	  USER_NAME,
	  LOGIN_TIMESTAMP,
	  LOGOUT_TIMESTAMP,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.AUDIT_ID,
	  NEW.USER_NAME,
	  NEW.LOGIN_TIMESTAMP,
	  NEW.LOGOUT_TIMESTAMP,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  '0',
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_USER
------------------------------------------------

CREATE TRIGGER TRU_USER
  AFTER UPDATE OF 
	  USER_ID,
	  TEAM_ID,
	  USER_NAME,
	  USER_FIRST_NAME,
	  USER_LAST_NAME,
	  USER_PHONE_NUM,
	  USER_STATUS,
	  USER_EMAIL_ADDRESS,
	  LAST_LOGIN_TIMESTAMP,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LOGICAL_DEL_IND
  ON FCM_USER
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_USER 	(
	  USER_ID,
	  TEAM_ID,
	  USER_NAME,
	  USER_FIRST_NAME,
	  USER_LAST_NAME,
	  USER_PHONE_NUM,
	  USER_STATUS,
	  USER_EMAIL_ADDRESS,
	  LAST_LOGIN_TIMESTAMP,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.USER_ID,
	  NEW.TEAM_ID,
	  NEW.USER_NAME,
	  NEW.USER_FIRST_NAME,
	  NEW.USER_LAST_NAME,
	  NEW.USER_PHONE_NUM,
	  NEW.USER_STATUS,
	  NEW.USER_EMAIL_ADDRESS,
	  NEW.LAST_LOGIN_TIMESTAMP,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  NEW.LOGICAL_DEL_IND,
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@
------------------------------------------------
-- DDL Statements for TRIGGER TRU_USR_ALRTTYPE
------------------------------------------------

CREATE TRIGGER TRU_USR_ALRTTYPE
  AFTER UPDATE OF 
	  USER_ID,
	  ALERT_TYPE,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  CREATE_USER,
	  CREATE_TIMESTAMP
  ON FCM_USER_ALERT_TYPE
  REFERENCING
              NEW AS NEW
  FOR EACH ROW
BEGIN ATOMIC
	INSERT INTO FSX_USER_ALERT_TYPE 	(
	  USER_ID,
	  ALERT_TYPE,
	  CREATE_USER,
	  CREATE_TIMESTAMP,
	  LSTUPDT_USER,
	  LSTUPDT_TIMESTAMP,
	  LSTUPDT_NBR,
	  LOGICAL_DEL_IND,
	  FSX_ACTION_TYPE,
	  FSX_CREATE_TIMESTAMP) 
	values (
	  NEW.USER_ID,
	  NEW.ALERT_TYPE,
	  NEW.CREATE_USER,
	  NEW.CREATE_TIMESTAMP,
	  NEW.LSTUPDT_USER,
	  NEW.LSTUPDT_TIMESTAMP,
	  NEW.LSTUPDT_NBR,
	  '0',
	  'UPDATE',
	  CURRENT TIMESTAMP
	);
END@


insert into fcm_version(VERSION_NAME , VERSION_NUM , VERSION_DATE , VERSION_DESC, VERSION_COMPONENT) VALUES
('Base DDL', '3.1.0.15 ', current date, '3.1.0.15 Hotfix DDL', 'DDL')
@
